#include <bits/stdc++.h>
typedef long long ll;
using namespace std;
// bogami grci se
// najsumnjiviji kod ikada

const int N = 1000;
const int INF = 1e9;

int n, m;
int a[N][N];
int dp[N][N];

int minimalnaSumaPuteva(int x, int y)
{
    memset(dp, 0x3f, sizeof dp);
    dp[0][0] = a[0][0];
    x--; y--;
    int temp = a[x][y];
    // stavi na inf da ga ne cita
    a[x][y] = INF;
    for(int i=1;i<n;++i)
    {
        dp[i][0] = dp[i-1][0] + a[i][0];
    }
    for(int j=1;j<m;++j)
    {
        dp[0][j] = dp[0][j-1] + a[0][j];
    }

    // le classic dp
    for(int i=1;i<n;++i)
    {
        for(int j=1;j<m;++j)
        {
            if(i+1==x && j+1==y)
                continue;
            dp[i][j] = min(dp[i-1][j], dp[i][j-1]) + a[i][j];
        }
    }
    // vrati vrednost na pocetnu
    a[x][y] = temp;
    return dp[n-1][m-1];
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    for(int i=0;i<n;++i)
    {
        for(int j=0;j<m;++j)
        {
            cin >> a[i][j];
        }
    }
    int Q, x, y;
    cin >> Q;
    for(int q=0;q<Q;++q)
    {
        cin >> x >> y;
        cout << minimalnaSumaPuteva(x, y) << endl;
    }
}